# Copyright (c) 2009 Benjamin Wohlwend
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell 
# copies of the Software, and to permit persons to whom the Software is 
# furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in 
# all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE. 

import sys

from PyQt4 import QtCore, QtGui

from undercover.gui.mainwindow import UnderCover
from undercover.util import ProxyConfigurator, check_appdir

if __name__ == "__main__":
    check_appdir()
    app = QtGui.QApplication(sys.argv)
    the_settings = QtCore.QSettings(QtCore.QSettings.IniFormat, 
                                QtCore.QSettings.UserScope, 
                                'piquadrat.ch', 'underCover')
    
    window = UnderCover()
    pos = the_settings.value("window_pos", QtCore.QVariant(QtCore.QPoint(30, 30))).toPoint();
    size = the_settings.value("window_size", QtCore.QVariant(QtCore.QSize(700, 500))).toSize();
    is_maximized = the_settings.value('window_maximized', QtCore.QVariant(False)).toBool()
    window.move(pos)
    window.resize(size)
    status = None
    if is_maximized:
        window.showMaximized()
    else:
        window.show()
    try:
        status = app.exec_()
    except:
        pass
    finally:
        # reset proxy settings if we changed them
        ProxyConfigurator.reset()
        sys.exit(status)